## org.apache.lucene.analysis
Class Token

    java.lang.Object
      org.apache.lucene.util.AttributeImpl
          org.apache.lucene.analysis.Token

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, FlagsAttribute, OffsetAttribute, PayloadAttribute, PositionIncrementAttribute, TermAttribute, TypeAttribute, Attribute

    public class Token

extends AttributeImpl
implements java.lang.Cloneable, TermAttribute, TypeAttribute, PositionIncrementAttribute, FlagsAttribute, OffsetAttribute, PayloadAttribute

A Token is an occurrence of a term from the text of a field. It consists of a term's text, the start and end offset of the term in the text of the field, and a type string.

The start and end offsets permit applications to re-associate a token with its source text, e.g., to display highlighted query terms in a document browser, or to show matching text fragments in a KWIC display, etc.

The type is a string, assigned by a lexical analyzer (a.k.a. tokenizer), naming the lexical or syntactic class that the token belongs to. For example an end of sentence marker token might be implemented with type "eos". The default token type is "word".

A Token can optionally have metadata (a.k.a. Payload) in the form of a variable length byte array. Use `TermPositions.getPayloadLength()` and `TermPositions.getPayload(byte[], int)` to retrieve the payloads from the index.

NOTE: As of 2.9, Token implements all `Attribute` interfaces that are part of core Lucene and can be found in the `tokenattributes` subpackage. Even though it is not necessary to use Token anymore, with the new TokenStream API it can be used as convenience class that implements all `Attribute`s, which is especially useful to easily switch from the old to the new TokenStream API.

NOTE: As of 2.3, Token stores the term text internally as a malleable char[] termBuffer instead of String termText. The indexing code and core tokenizers have been changed to re-use a single Token instance, changing its buffer and other fields in-place as the Token is processed. This provides substantially better indexing performance as it saves the GC cost of new'ing a Token and String for every term. The APIs that accept String termText are still available but a warning about the associated performance cost has been added (below). The `termText()` method has been deprecated.

Tokenizers and TokenFilters should try to re-use a Token instance when possible for best performance, by implementing the `TokenStream.incrementToken()` API. Failing that, to create a new Token you should first use one of the constructors that starts with null text. To load the token from a char[] use `setTermBuffer(char[], int, int)`. To load from a String use `setTermBuffer(String)` or `setTermBuffer(String, int, int)`. Alternatively you can get the Token's termBuffer by calling either `termBuffer()`, if you know that your text is shorter than the capacity of the termBuffer or `resizeTermBuffer(int)`, if there is any possibility that you may need to grow the buffer. Fill in the characters of your term into this buffer, with `String.getChars(int, int, char[], int)` if loading from a string, or with `System.arraycopy(Object, int, Object, int, int)`, and finally call `setTermLength(int)` to set the length of the term text. See LUCENE-969 for details.

Typical Token reuse patterns:

- Copying text from a string (type is reset to `DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(string, startOffset, endOffset[, type]);

- Copying some text from a string (type is reset to `DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(string, 0, string.length(), startOffset, endOffset[, type]);

- Copying text from char[] buffer (type is reset to `DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(buffer, 0, buffer.length, startOffset, endOffset[, type]);

- Copying some text from a char[] buffer (type is reset to `DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(buffer, start, end - start, startOffset, endOffset[, type]);

- Copying from one one Token to another (type is reset to `DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(source.termBuffer(), 0, source.termLength(), source.startOffset(), source.endOffset()[, source.type()]);

A few things to note:

- clear() initializes all of the fields to default values. This was changed in contrast to Lucene 2.4, but should affect no one.
- Because `TokenStreams` can be chained, one cannot assume that the `Token's` current type is correct.
- The startOffset and endOffset represent the start and offset in the source text, so be careful in adjusting them.
- When caching a reusable token, clone it. When injecting a cached token into a stream that can be reset, clone it again.

See Also:
  `Payload`, Serialized Form

Field Summary
`static java.lang.String` `DEFAULT_TYPE`

Constructor Summary
`Token()` Constructs a Token will null text.
`Token(char[] startTermBuffer, int termBufferOffset, int termBufferLength, int start, int end)` Constructs a Token with the given term buffer (offset & length), start and end offsets
`Token(int start, int end)` Constructs a Token with null text and start & end offsets.
`Token(int start, int end, int flags)` Constructs a Token with null text and start & end offsets plus flags.
`Token(int start, int end, java.lang.String typ)` Constructs a Token with null text and start & end offsets plus the Token type.
`Token(java.lang.String text, int start, int end)` Constructs a Token with the given term text, and start & end offsets.
`Token(java.lang.String text, int start, int end, int flags)` Constructs a Token with the given text, start and end offsets, & type.
`Token(java.lang.String text, int start, int end, java.lang.String typ)` Constructs a Token with the given text, start and end offsets, & type.

Method Summary
`void` `clear()` Resets the term text, payload, flags, and positionIncrement, startOffset, endOffset and token type to default.
`java.lang.Object` `clone()` Shallow clone.
`Token` `clone(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Makes a clone, but replaces the term buffer & start/end offset in the process.
`void` `copyTo(AttributeImpl target)` Copies the values from this Attribute into the passed-in target attribute.
`int` `endOffset()` Returns this Token's ending offset, one greater than the position of the last character corresponding to this token in the source text.
`boolean` `equals(java.lang.Object obj)` All values used for computation of `AttributeImpl.hashCode()` should be checked here for equality.
`int` `getFlags()` EXPERIMENTAL: While we think this is here to stay, we may want to change it to be a long.
`Payload` `getPayload()` Returns this Token's payload.
`int` `getPositionIncrement()` Returns the position increment of this Token.
`int` `hashCode()` Subclasses must implement this method and should compute a hashCode similar to this:
`Token` `reinit(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `setTermBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` `reinit(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset, java.lang.String newType)` Shorthand for calling `clear()`, `setTermBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)`, `setType(java.lang.String)`
`Token` `reinit(java.lang.String newTerm, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `setTermBuffer(String)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` `reinit(java.lang.String newTerm, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `setTermBuffer(String, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` `reinit(java.lang.String newTerm, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset, java.lang.String newType)` Shorthand for calling `clear()`, `setTermBuffer(String, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`
`Token` `reinit(java.lang.String newTerm, int newStartOffset, int newEndOffset, java.lang.String newType)` Shorthand for calling `clear()`, `setTermBuffer(String)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`
`void` `reinit(Token prototype)` Copy the prototype token's fields into this one.
`void` `reinit(Token prototype, char[] newTermBuffer, int offset, int length)` Copy the prototype token's fields into this one, with a different term.
`void` `reinit(Token prototype, java.lang.String newTerm)` Copy the prototype token's fields into this one, with a different term.
`char[]` `resizeTermBuffer(int newSize)` Grows the termBuffer to at least size newSize, preserving the existing content.
`void` `setEndOffset(int offset)` Set the ending offset.
`void` `setFlags(int flags)`
`void` `setOffset(int startOffset, int endOffset)` Set the starting and ending offset.
`void` `setPayload(Payload payload)` Sets this Token's payload.
`void` `setPositionIncrement(int positionIncrement)` Set the position increment.
`void` `setStartOffset(int offset)` Set the starting offset.
`void` `setTermBuffer(char[] buffer, int offset, int length)` Copies the contents of buffer, starting at offset for length characters, into the termBuffer array.
`void` `setTermBuffer(java.lang.String buffer)` Copies the contents of buffer into the termBuffer array.
`void` `setTermBuffer(java.lang.String buffer, int offset, int length)` Copies the contents of buffer, starting at offset and continuing for length characters, into the termBuffer array.
`void` `setTermLength(int length)` Set number of valid characters (length of the term) in the termBuffer array.
`void` `setTermText(java.lang.String text)` Deprecated. use `setTermBuffer(char[], int, int)` or `setTermBuffer(String)` or `setTermBuffer(String, int, int)`.
`void` `setType(java.lang.String type)` Set the lexical type.
`int` `startOffset()` Returns this Token's starting offset, the position of the first character corresponding to this token in the source text.
`java.lang.String` `term()` Returns the Token's term text.
`char[]` `termBuffer()` Returns the internal termBuffer character array which you can then directly alter.
`int` `termLength()` Return number of valid characters (length of the term) in the termBuffer array.
`java.lang.String` `termText()` Deprecated. This method now has a performance penalty because the text is stored internally in a char[]. If possible, use `termBuffer()` and `termLength()` directly instead. If you really need a String, use `term()`
`java.lang.String` `toString()` The default implementation of this method accesses all declared fields of this object and prints the values in the following syntax:
`java.lang.String` `type()` Returns this Token's lexical type.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### DEFAULT_TYPE

    public static final java.lang.String DEFAULT_TYPE

See Also:
  Constant Field Values

Constructor Detail

### Token

    public Token()

  Constructs a Token will null text.

### Token

    public Token(int start,
                 int end)

  Constructs a Token with null text and start & end offsets.

  Parameters:
    `start` - start offset in the source text
    `end` - end offset in the source text

### Token

    public Token(int start,
                 int end,
                 java.lang.String typ)

  Constructs a Token with null text and start & end offsets plus the Token type.

  Parameters:
    `start` - start offset in the source text
    `end` - end offset in the source text
    `typ` - the lexical type of this Token

### Token

    public Token(int start,
                 int end,
                 int flags)

  Constructs a Token with null text and start & end offsets plus flags. NOTE: flags is EXPERIMENTAL.

  Parameters:
    `start` - start offset in the source text
    `end` - end offset in the source text
    `flags` - The bits to set for this token

### Token

    public Token(java.lang.String text,
                 int start,
                 int end)

  Constructs a Token with the given term text, and start & end offsets. The type defaults to "word." NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

  Parameters:
    `text` - term text
    `start` - start offset
    `end` - end offset

### Token

    public Token(java.lang.String text,
                 int start,
                 int end,
                 java.lang.String typ)

  Constructs a Token with the given text, start and end offsets, & type. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

  Parameters:
    `text` - term text
    `start` - start offset
    `end` - end offset
    `typ` - token type

### Token

    public Token(java.lang.String text,
                 int start,
                 int end,
                 int flags)

  Constructs a Token with the given text, start and end offsets, & type. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

  Parameters:
    `text` -
    `start` -
    `end` -
    `flags` - token type bits

### Token

    public Token(char[] startTermBuffer,
                 int termBufferOffset,
                 int termBufferLength,
                 int start,
                 int end)

  Constructs a Token with the given term buffer (offset & length), start and end offsets

  Parameters:
    `startTermBuffer` -
    `termBufferOffset` -
    `termBufferLength` -
    `start` -
    `end` -

Method Detail

### setPositionIncrement

    public void setPositionIncrement(int positionIncrement)

  Set the position increment. This determines the position of this token relative to the previous Token in a `TokenStream`, used in phrase searching.

  The default value is one.

  Some common uses for this are:

  - Set it to zero to put multiple terms in the same position. This is useful if, e.g., a word has multiple stems. Searches for phrases including either stem will match. In this case, all but the first stem's increment should be set to zero: the increment of the first instance should be one. Repeating a token with an increment of zero can also be used to boost the scores of matches on that token.
  - Set it to values greater than one to inhibit exact phrase matches. If, for example, one does not want phrases to match across removed stop words, then one could build a stop word filter that removes stop words and also sets the increment to the number of stop words removed before each non-stop word. Then exact phrase queries will only match when the terms occur with no intervening stop words.

  Specified by:
    `setPositionIncrement` in interface `PositionIncrementAttribute`
  Parameters:
    `positionIncrement` - the distance from the prior term
  See Also:
    `TermPositions`

### getPositionIncrement

    public int getPositionIncrement()

  Returns the position increment of this Token.

  Specified by:
    `getPositionIncrement` in interface `PositionIncrementAttribute`
  See Also:
    `setPositionIncrement(int)`

### setTermText

    public void setTermText(java.lang.String text)

  Deprecated. use `setTermBuffer(char[], int, int)` or `setTermBuffer(String)` or `setTermBuffer(String, int, int)`.

  Sets the Token's term text. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

### termText

    public final java.lang.String termText()

  Deprecated. This method now has a performance penalty because the text is stored internally in a char[]. If possible, use `termBuffer()` and `termLength()` directly instead. If you really need a String, use `term()`

  Returns the Token's term text.

### term

    public final java.lang.String term()

  Returns the Token's term text. This method has a performance penalty because the text is stored internally in a char[]. If possible, use `termBuffer()` and `termLength()` directly instead. If you really need a String, use this method, which is nothing more than a convenience call to new String(token.termBuffer(), 0, token.termLength())

  Specified by:
    `term` in interface `TermAttribute`

### setTermBuffer

    public final void setTermBuffer(char[] buffer,
                                    int offset,
                                    int length)

  Copies the contents of buffer, starting at offset for length characters, into the termBuffer array.

  Specified by:
    `setTermBuffer` in interface `TermAttribute`
  Parameters:
    `buffer` - the buffer to copy
    `offset` - the index in the buffer of the first character to copy
    `length` - the number of characters to copy

### setTermBuffer

    public final void setTermBuffer(java.lang.String buffer)

  Copies the contents of buffer into the termBuffer array.

  Specified by:
    `setTermBuffer` in interface `TermAttribute`
  Parameters:
    `buffer` - the buffer to copy

### setTermBuffer

    public final void setTermBuffer(java.lang.String buffer,
                                    int offset,
                                    int length)

  Copies the contents of buffer, starting at offset and continuing for length characters, into the termBuffer array.

  Specified by:
    `setTermBuffer` in interface `TermAttribute`
  Parameters:
    `buffer` - the buffer to copy
    `offset` - the index in the buffer of the first character to copy
    `length` - the number of characters to copy

### termBuffer

    public final char[] termBuffer()

  Returns the internal termBuffer character array which you can then directly alter. If the array is too small for your token, use `resizeTermBuffer(int)` to increase it. After altering the buffer be sure to call `setTermLength(int)` to record the number of valid characters that were placed into the termBuffer.

  Specified by:
    `termBuffer` in interface `TermAttribute`

### resizeTermBuffer

    public char[] resizeTermBuffer(int newSize)

  Grows the termBuffer to at least size newSize, preserving the existing content. Note: If the next operation is to change the contents of the term buffer use `setTermBuffer(char[], int, int)`, `setTermBuffer(String)`, or `setTermBuffer(String, int, int)` to optimally combine the resize with the setting of the termBuffer.

  Specified by:
    `resizeTermBuffer` in interface `TermAttribute`
  Parameters:
    `newSize` - minimum size of the new termBuffer
  Returns:
    newly created termBuffer with length >= newSize

### termLength

    public final int termLength()

  Return number of valid characters (length of the term) in the termBuffer array.

  Specified by:
    `termLength` in interface `TermAttribute`

### setTermLength

    public final void setTermLength(int length)

  Set number of valid characters (length of the term) in the termBuffer array. Use this to truncate the termBuffer or to synchronize with external manipulation of the termBuffer. Note: to grow the size of the array, use `resizeTermBuffer(int)` first.

  Specified by:
    `setTermLength` in interface `TermAttribute`
  Parameters:
    `length` - the truncated length

### startOffset

    public final int startOffset()

  Returns this Token's starting offset, the position of the first character corresponding to this token in the source text. Note that the difference between endOffset() and startOffset() may not be equal to termText.length(), as the term text may have been altered by a stemmer or some other filter.

  Specified by:
    `startOffset` in interface `OffsetAttribute`

### setStartOffset

    public void setStartOffset(int offset)

  Set the starting offset.

  See Also:
    `startOffset()`

### endOffset

    public final int endOffset()

  Returns this Token's ending offset, one greater than the position of the last character corresponding to this token in the source text. The length of the token in the source text is (endOffset - startOffset).

  Specified by:
    `endOffset` in interface `OffsetAttribute`

### setEndOffset

    public void setEndOffset(int offset)

  Set the ending offset.

  See Also:
    `endOffset()`

### setOffset

    public void setOffset(int startOffset,
                          int endOffset)

  Set the starting and ending offset.

  Specified by:
    `setOffset` in interface `OffsetAttribute`
  See Also:
    `and #endOffset()`

### type

    public final java.lang.String type()

  Returns this Token's lexical type. Defaults to "word".

  Specified by:
    `type` in interface `TypeAttribute`

### setType

    public final void setType(java.lang.String type)

  Set the lexical type.

  Specified by:
    `setType` in interface `TypeAttribute`
  See Also:
    `type()`

### getFlags

    public int getFlags()

  EXPERIMENTAL: While we think this is here to stay, we may want to change it to be a long.

  Get the bitset for any bits that have been set. This is completely distinct from `type()`, although they do share similar purposes. The flags can be used to encode information about the token for use by other `TokenFilter`s.

  Specified by:
    `getFlags` in interface `FlagsAttribute`
  Returns:
    The bits

### setFlags

    public void setFlags(int flags)

  Specified by:
    `setFlags` in interface `FlagsAttribute`
  See Also:
    `getFlags()`

### getPayload

    public Payload getPayload()

  Returns this Token's payload.

  Specified by:
    `getPayload` in interface `PayloadAttribute`

### setPayload

    public void setPayload(Payload payload)

  Sets this Token's payload.

  Specified by:
    `setPayload` in interface `PayloadAttribute`

### toString

    public java.lang.String toString()

  Description copied from class: `AttributeImpl`
  The default implementation of this method accesses all declared fields of this object and prints the values in the following syntax:

         public String toString() {
           return "start=" + startOffset + ",end=" + endOffset;
         }

  This method may be overridden by subclasses.

  Overrides:
    `toString` in class `AttributeImpl`

### clear

    public void clear()

  Resets the term text, payload, flags, and positionIncrement, startOffset, endOffset and token type to default.

  Specified by:
    `clear` in class `AttributeImpl`

### clone

    public java.lang.Object clone()

  Description copied from class: `AttributeImpl`
  Shallow clone. Subclasses must override this if they need to clone any members deeply,

  Overrides:
    `clone` in class `AttributeImpl`

### clone

    public Token clone(char[] newTermBuffer,
                       int newTermOffset,
                       int newTermLength,
                       int newStartOffset,
                       int newEndOffset)

  Makes a clone, but replaces the term buffer & start/end offset in the process. This is more efficient than doing a full clone (and then calling setTermBuffer) because it saves a wasted copy of the old termBuffer.

### equals

    public boolean equals(java.lang.Object obj)

  Description copied from class: `AttributeImpl`
  All values used for computation of `AttributeImpl.hashCode()` should be checked here for equality. see also `Object.equals(Object)`

  Specified by:
    `equals` in class `AttributeImpl`

### hashCode

    public int hashCode()

  Description copied from class: `AttributeImpl`
  Subclasses must implement this method and should compute a hashCode similar to this:

         public int hashCode() {
           int code = startOffset;
           code = code * 31 + endOffset;
           return code;
         }

  see also `AttributeImpl.equals(Object)`

  Specified by:
    `hashCode` in class `AttributeImpl`

### reinit

    public Token reinit(char[] newTermBuffer,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset,
                        java.lang.String newType)

  Shorthand for calling `clear()`, `setTermBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)`, `setType(java.lang.String)`

  Returns:
    this Token instance

### reinit

    public Token reinit(char[] newTermBuffer,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset)

  Shorthand for calling `clear()`, `setTermBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE

  Returns:
    this Token instance

### reinit

    public Token reinit(java.lang.String newTerm,
                        int newStartOffset,
                        int newEndOffset,
                        java.lang.String newType)

  Shorthand for calling `clear()`, `setTermBuffer(String)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`

  Returns:
    this Token instance

### reinit

    public Token reinit(java.lang.String newTerm,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset,
                        java.lang.String newType)

  Shorthand for calling `clear()`, `setTermBuffer(String, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`

  Returns:
    this Token instance

### reinit

    public Token reinit(java.lang.String newTerm,
                        int newStartOffset,
                        int newEndOffset)

  Shorthand for calling `clear()`, `setTermBuffer(String)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE

  Returns:
    this Token instance

### reinit

    public Token reinit(java.lang.String newTerm,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset)

  Shorthand for calling `clear()`, `setTermBuffer(String, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE

  Returns:
    this Token instance

### reinit

    public void reinit(Token prototype)

  Copy the prototype token's fields into this one. Note: Payloads are shared.

  Parameters:
    `prototype` -

### reinit

    public void reinit(Token prototype,
                       java.lang.String newTerm)

  Copy the prototype token's fields into this one, with a different term. Note: Payloads are shared.

  Parameters:
    `prototype` -
    `newTerm` -

### reinit

    public void reinit(Token prototype,
                       char[] newTermBuffer,
                       int offset,
                       int length)

  Copy the prototype token's fields into this one, with a different term. Note: Payloads are shared.

  Parameters:
    `prototype` -
    `newTermBuffer` -
    `offset` -
    `length` -

### copyTo

    public void copyTo(AttributeImpl target)

  Description copied from class: `AttributeImpl`
  Copies the values from this Attribute into the passed-in target attribute. The target implementation must support all the Attributes this implementation supports.

  Specified by:
    `copyTo` in class `AttributeImpl`

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.